diff --git a/cmd/telemetry-gateway/internal/server/publish_events.go b/cmd/telemetry-gateway/internal/server/publish_events.go
new file mode 100644
index 00000000000..e302675f2b7
--- /dev/null
+++ b/cmd/telemetry-gateway/internal/server/publish_events.go
@@ -0,0 +1,113 @@
+package server
+
+import (
+	"context"
+	"fmt"
+
+	"github.com/sourcegraph/log"
+	"go.opentelemetry.io/otel/attribute"
+	"go.opentelemetry.io/otel/metric"
+	"go.opentelemetry.io/otel/trace"
+
+	"github.com/sourcegraph/sourcegraph/cmd/telemetry-gateway/internal/events"
+	telemetrygatewayv1 "github.com/sourcegraph/sourcegraph/internal/telemetrygateway/v1"
+	sgtrace "github.com/sourcegraph/sourcegraph/internal/trace"
+	"github.com/sourcegraph/sourcegraph/lib/errors"
+)
+
+func handlePublishEvents(
+	ctx context.Context,
+	logger log.Logger,
+	payloadMetrics *recordEventsRequestPayloadMetrics,
+	publisher *events.Publisher,
+	events []*telemetrygatewayv1.Event,
+) *telemetrygatewayv1.RecordEventsResponse {
+	var tr sgtrace.Trace
+	tr, ctx = sgtrace.New(ctx, "handlePublishEvents",
+		attribute.Int("events", len(events)))
+	defer tr.End()
+
+	logger = sgtrace.Logger(ctx, logger)
+
+	// Send off our events
+	results := publisher.Publish(ctx, events)
+
+	// Aggregate failure details
+	summary := summarizePublishEventsResults(results)
+
+	// Record the result on the trace and metrics
+	resultAttribute := attribute.String("result", summary.result)
+	tr.SetAttributes(resultAttribute)
+	payloadMetrics.length.Record(ctx, int64(len(events)),
+		metric.WithAttributes(resultAttribute))
+	payloadMetrics.failedEvents.Add(ctx, int64(len(summary.failedEvents)),
+		metric.WithAttributes(resultAttribute))
+
+	// Generate a log message for convenience
+	summaryFields := []log.Field{
+		log.String("result", summary.result),
+		log.Int("submitted", len(events)),
+		log.Int("succeeded", len(summary.succeededEvents)),
+		log.Int("failed", len(summary.failedEvents)),
+	}
+	if len(summary.failedEvents) > 0 {
+		tr.RecordError(errors.New(summary.message),
+			trace.WithAttributes(attribute.Int("failed", len(summary.failedEvents))))
+		logger.Error(summary.message, append(summaryFields, summary.errorFields...)...)
+	} else {
+		logger.Info(summary.message, summaryFields...)
+	}
+
+	return &telemetrygatewayv1.RecordEventsResponse{
+		SucceededEvents: summary.succeededEvents,
+	}
+}
+
+type publishEventsSummary struct {
+	// message is a human-readable summary summarizing the result
+	message string
+	// result is a low-cardinality indicator of the result category
+	result string
+
+	errorFields     []log.Field
+	succeededEvents []string
+	failedEvents    []events.PublishEventResult
+}
+
+func summarizePublishEventsResults(results []events.PublishEventResult) publishEventsSummary {
+	var (
+		errFields = make([]log.Field, 0)
+		succeeded = make([]string, 0, len(results))
+		failed    = make([]events.PublishEventResult, 0)
+	)
+
+	for i, result := range results {
+		if result.PublishError != nil {
+			failed = append(failed, result)
+			errFields = append(errFields, log.NamedError(fmt.Sprintf("error.%d", i), result.PublishError))
+		} else {
+			succeeded = append(succeeded, result.EventID)
+		}
+	}
+
+	var message, category string
+	switch {
+	case len(failed) == len(results):
+		message = "all events in batch failed to submit"
+		category = "complete_failure"
+	case len(failed) > 0 && len(failed) < len(results):
+		message = "some events in batch failed to submit"
+		category = "partial_failure"
+	case len(failed) == 0:
+		message = "all events in batch submitted successfully"
+		category = "success"
+	}
+
+	return publishEventsSummary{
+		message:         message,
+		result:          category,
+		errorFields:     errFields,
+		succeededEvents: succeeded,
+		failedEvents:    failed,
+	}
+}
diff --git a/cmd/telemetry-gateway/internal/server/publish_events_test.go b/cmd/telemetry-gateway/internal/server/publish_events_test.go
new file mode 100644
index 00000000000..f27bbd773ba
--- /dev/null
+++ b/cmd/telemetry-gateway/internal/server/publish_events_test.go
@@ -0,0 +1,60 @@
+package server
+
+import (
+	"errors"
+	"strconv"
+	"testing"
+
+	"github.com/hexops/autogold/v2"
+	"github.com/stretchr/testify/assert"
+
+	"github.com/sourcegraph/sourcegraph/cmd/telemetry-gateway/internal/events"
+)
+
+func TestSummarizeFailedEvents(t *testing.T) {
+	t.Run("all failed", func(t *testing.T) {
+		results := make([]events.PublishEventResult, 0)
+		for i := range results {
+			results[i].EventID = "id_" + strconv.Itoa(i)
+			results[i].PublishError = errors.New("failed")
+		}
+
+		summary := summarizePublishEventsResults(results)
+		autogold.Expect("all events in batch failed to submit").Equal(t, summary.message)
+		autogold.Expect("complete_failure").Equal(t, summary.result)
+		assert.Len(t, summary.errorFields, len(results))
+		assert.Len(t, summary.succeededEvents, 0)
+		assert.Len(t, summary.failedEvents, len(results))
+	})
+
+	t.Run("some failed", func(t *testing.T) {
+		results := []events.PublishEventResult{{
+			EventID:      "asdf",
+			PublishError: errors.New("oh no"),
+		}, {
+			EventID: "asdfasdf",
+		}}
+
+		summary := summarizePublishEventsResults(results)
+		autogold.Expect("some events in batch failed to submit").Equal(t, summary.message)
+		autogold.Expect("partial_failure").Equal(t, summary.result)
+		assert.Len(t, summary.errorFields, 1)
+		assert.Len(t, summary.succeededEvents, 1)
+		assert.Len(t, summary.failedEvents, 1)
+	})
+
+	t.Run("all succeeded", func(t *testing.T) {
+		results := []events.PublishEventResult{{
+			EventID: "asdf",
+		}, {
+			EventID: "asdfasdf",
+		}}
+
+		summary := summarizePublishEventsResults(results)
+		autogold.Expect("all events in batch submitted successfully").Equal(t, summary.message)
+		autogold.Expect("success").Equal(t, summary.result)
+		assert.Len(t, summary.errorFields, 0)
+		assert.Len(t, summary.succeededEvents, 2)
+		assert.Len(t, summary.failedEvents, 0)
+	})
+}
diff --git a/cmd/telemetry-gateway/internal/server/server.go b/cmd/telemetry-gateway/internal/server/server.go
new file mode 100644
index 00000000000..22cb92bde7e
--- /dev/null
+++ b/cmd/telemetry-gateway/internal/server/server.go
@@ -0,0 +1,138 @@
+package server
+
+import (
+	"fmt"
+	"io"
+
+	"go.opentelemetry.io/otel/attribute"
+	"go.opentelemetry.io/otel/metric"
+	"google.golang.org/grpc/codes"
+	"google.golang.org/grpc/status"
+
+	"github.com/sourcegraph/log"
+
+	"github.com/sourcegraph/sourcegraph/cmd/telemetry-gateway/internal/events"
+	"github.com/sourcegraph/sourcegraph/internal/licensing"
+	"github.com/sourcegraph/sourcegraph/internal/pubsub"
+	sgtrace "github.com/sourcegraph/sourcegraph/internal/trace"
+	"github.com/sourcegraph/sourcegraph/lib/errors"
+
+	telemetrygatewayv1 "github.com/sourcegraph/sourcegraph/internal/telemetrygateway/v1"
+)
+
+type Server struct {
+	logger      log.Logger
+	eventsTopic pubsub.TopicClient
+
+	recordEventsMetrics recordEventsMetrics
+
+	// Fallback unimplemented handler
+	telemetrygatewayv1.UnimplementedTelemeteryGatewayServiceServer
+}
+
+var _ telemetrygatewayv1.TelemeteryGatewayServiceServer = (*Server)(nil)
+
+func New(logger log.Logger, eventsTopic pubsub.TopicClient) (*Server, error) {
+	m, err := newRecordEventsMetrics()
+	if err != nil {
+		return nil, err
+	}
+
+	return &Server{
+		logger:      logger.Scoped("server", "grpc server"),
+		eventsTopic: eventsTopic,
+
+		recordEventsMetrics: m,
+	}, nil
+}
+
+func (s *Server) RecordEvents(stream telemetrygatewayv1.TelemeteryGatewayService_RecordEventsServer) (err error) {
+	var (
+		logger = sgtrace.Logger(stream.Context(), s.logger)
+		// publisher is initialized once for RecordEventsRequestMetadata.
+		publisher *events.Publisher
+		// count of all processed events, collected at the end of a request
+		totalProcessedEvents int64
+	)
+
+	defer func() {
+		s.recordEventsMetrics.totalLength.Record(stream.Context(),
+			totalProcessedEvents,
+			metric.WithAttributes(attribute.Bool("error", err != nil)))
+	}()
+
+	for {
+		msg, err := stream.Recv()
+		if errors.Is(err, io.EOF) {
+			break
+		}
+		if err != nil {
+			return err
+		}
+
+		switch msg.Payload.(type) {
+		case *telemetrygatewayv1.RecordEventsRequest_Metadata:
+			if publisher != nil {
+				return status.Error(codes.InvalidArgument, "received metadata more than once")
+			}
+
+			metadata := msg.GetMetadata()
+			logger = logger.With(log.String("request_id", metadata.GetRequestId()))
+
+			// Validate self-reported instance identifier
+			switch metadata.GetIdentifier().Identifier.(type) {
+			case *telemetrygatewayv1.Identifier_LicensedInstance:
+				licenseKey := metadata.Identifier.GetLicensedInstance().GetLicenseKey()
+				licenseInfo, _, err := licensing.ParseProductLicenseKey(licenseKey)
+				if err != nil {
+					return status.Errorf(codes.InvalidArgument, "invalid license key: %s", err)
+				}
+				logger.Info("handling events submission stream for licensed instance",
+					log.Stringp("license.salesforceOpportunityID", licenseInfo.SalesforceOpportunityID),
+					log.Stringp("license.salesforceSubscriptionID", licenseInfo.SalesforceSubscriptionID))
+
+			default:
+				logger.Error("unknown identifier type",
+					log.String("type", fmt.Sprintf("%T", metadata.Identifier.Identifier)))
+				return status.Error(codes.Unimplemented, "unsupported identifier type")
+			}
+
+			// Set up a publisher with the provided metadata
+			publisher, err = events.NewPublisherForStream(s.eventsTopic, metadata)
+			if err != nil {
+				return status.Errorf(codes.Internal, "failed to create publisher: %v", err)
+			}
+
+		case *telemetrygatewayv1.RecordEventsRequest_Events:
+			events := msg.GetEvents().GetEvents()
+			if publisher == nil {
+				return status.Error(codes.InvalidArgument, "got events when metadata not yet received")
+			}
+
+			// Publish events
+			resp := handlePublishEvents(
+				stream.Context(),
+				logger,
+				&s.recordEventsMetrics.payload,
+				publisher,
+				events)
+
+			// Update total count
+			totalProcessedEvents += int64(len(events))
+
+			// Let the client know what happened
+			if err := stream.Send(resp); err != nil {
+				return err
+			}
+
+		case nil:
+			continue
+
+		default:
+			return status.Errorf(codes.InvalidArgument, "got malformed message %T", msg.Payload)
+		}
+	}
+
+	logger.Info("request done")
+	return nil
+}
diff --git a/cmd/telemetry-gateway/main.go b/cmd/telemetry-gateway/main.go
new file mode 100644
index 00000000000..ca401858834
--- /dev/null
+++ b/cmd/telemetry-gateway/main.go
@@ -0,0 +1,33 @@
+package main
+
+import (
+	"github.com/getsentry/sentry-go"
+	"github.com/sourcegraph/log"
+
+	"github.com/sourcegraph/sourcegraph/cmd/telemetry-gateway/shared"
+	"github.com/sourcegraph/sourcegraph/internal/conf"
+	"github.com/sourcegraph/sourcegraph/internal/env"
+	"github.com/sourcegraph/sourcegraph/internal/sanitycheck"
+	"github.com/sourcegraph/sourcegraph/internal/service/svcmain"
+)
+
+var sentryDSN = env.Get("TELEMETRY_GATEWAY_SENTRY_DSN", "", "Sentry DSN")
+
+func main() {
+	sanitycheck.Pass()
+	svcmain.SingleServiceMainWithoutConf(shared.Service, svcmain.Config{}, svcmain.OutOfBandConfiguration{
+		Logging: func() conf.LogSinksSource {
+			if sentryDSN == "" {
+				return nil
+			}
+			return conf.NewStaticLogsSinksSource(log.SinksConfig{
+				Sentry: &log.SentrySink{
+					ClientOptions: sentry.ClientOptions{
+						Dsn: sentryDSN,
+					},
+				},
+			})
+		}(),
+		Tracing: nil,
+	})
+}
diff --git a/cmd/telemetry-gateway/shared/BUILD.bazel b/cmd/telemetry-gateway/shared/BUILD.bazel
new file mode 100644
index 00000000000..ff5d3d3476e
--- /dev/null
+++ b/cmd/telemetry-gateway/shared/BUILD.bazel
@@ -0,0 +1,43 @@
+load("@io_bazel_rules_go//go:def.bzl", "go_library")
+
+go_library(
+    name = "shared",
+    srcs = [
+        "config.go",
+        "main.go",
+        "metrics.go",
+        "service.go",
+        "tracing.go",
+    ],
+    importpath = "github.com/sourcegraph/sourcegraph/cmd/telemetry-gateway/shared",
+    visibility = ["//visibility:public"],
+    deps = [
+        "//cmd/telemetry-gateway/internal/diagnosticsserver",
+        "//cmd/telemetry-gateway/internal/server",
+        "//internal/debugserver",
+        "//internal/env",
+        "//internal/goroutine",
+        "//internal/grpc",
+        "//internal/grpc/defaults",
+        "//internal/httpserver",
+        "//internal/observation",
+        "//internal/pubsub",
+        "//internal/service",
+        "//internal/telemetrygateway/v1:telemetrygateway",
+        "//internal/trace/policy",
+        "//internal/tracer/oteldefaults",
+        "//internal/tracer/oteldefaults/exporters",
+        "//internal/version",
+        "//lib/errors",
+        "@com_github_googlecloudplatform_opentelemetry_operations_go_exporter_metric//:metric",
+        "@com_github_googlecloudplatform_opentelemetry_operations_go_exporter_trace//:trace",
+        "@com_github_sourcegraph_conc//:conc",
+        "@com_github_sourcegraph_log//:log",
+        "@io_opentelemetry_go_contrib_detectors_gcp//:gcp",
+        "@io_opentelemetry_go_otel//:otel",
+        "@io_opentelemetry_go_otel//semconv/v1.4.0:v1_4_0",
+        "@io_opentelemetry_go_otel_sdk//resource",
+        "@io_opentelemetry_go_otel_sdk//trace",
+        "@io_opentelemetry_go_otel_sdk_metric//:metric",
+    ],
+)
diff --git a/cmd/telemetry-gateway/shared/config.go b/cmd/telemetry-gateway/shared/config.go
new file mode 100644
index 00000000000..0c4e28cd804
--- /dev/null
+++ b/cmd/telemetry-gateway/shared/config.go
@@ -0,0 +1,54 @@
+package shared
+
+import (
+	"fmt"
+	"os"
+
+	"github.com/sourcegraph/sourcegraph/internal/env"
+	"github.com/sourcegraph/sourcegraph/internal/trace/policy"
+)
+
+type Config struct {
+	env.BaseConfig
+
+	Port              int
+	DiagnosticsSecret string
+
+	Events struct {
+		PubSub struct {
+			Enabled   bool
+			ProjectID string
+			TopicID   string
+		}
+	}
+
+	OpenTelemetry OpenTelemetryConfig
+}
+
+type OpenTelemetryConfig struct {
+	TracePolicy  policy.TracePolicy
+	GCPProjectID string
+}
+
+func (c *Config) Load() {
+	c.Port = c.GetInt("PORT", "10080", "Port to serve Telemetry Gateway service on, generally injected by Cloud Run.")
+	c.DiagnosticsSecret = c.Get("DIAGNOSTICS_SECRET", "", "Secret for accessing diagnostics - "+
+		"should be used as 'Authorization: Bearer $secret' header when accessing diagnostics endpoints.")
+
+	c.Events.PubSub.Enabled = c.GetBool("TELEMETRY_GATEWAY_EVENTS_PUBSUB_ENABLED", "true",
+		"If false, logs Pub/Sub messages instead of actually sending them")
+	c.Events.PubSub.ProjectID = c.GetOptional("TELEMETRY_GATEWAY_EVENTS_PUBSUB_PROJECT_ID",
+		"The project ID for the Pub/Sub.")
+	c.Events.PubSub.TopicID = c.GetOptional("TELEMETRY_GATEWAY_EVENTS_PUBSUB_TOPIC_ID",
+		"The topic ID for the Pub/Sub.")
+
+	c.OpenTelemetry.TracePolicy = policy.TracePolicy(c.Get("CODY_GATEWAY_TRACE_POLICY", "all", "Trace policy, one of 'all', 'selective', 'none'."))
+	c.OpenTelemetry.GCPProjectID = c.GetOptional("CODY_GATEWAY_OTEL_GCP_PROJECT_ID", "Google Cloud Traces project ID.")
+	if c.OpenTelemetry.GCPProjectID == "" {
+		c.OpenTelemetry.GCPProjectID = os.Getenv("GOOGLE_CLOUD_PROJECT")
+	}
+}
+
+func (c *Config) GetListenAdress() string {
+	return fmt.Sprintf(":%d", c.Port)
+}
diff --git a/cmd/telemetry-gateway/shared/main.go b/cmd/telemetry-gateway/shared/main.go
new file mode 100644
index 00000000000..4fe77213933
--- /dev/null
+++ b/cmd/telemetry-gateway/shared/main.go
@@ -0,0 +1,133 @@
+package shared
+
+import (
+	"context"
+	"net/http"
+	"time"
+
+	"github.com/sourcegraph/conc"
+	"github.com/sourcegraph/log"
+	"go.opentelemetry.io/contrib/detectors/gcp"
+	"go.opentelemetry.io/otel/sdk/resource"
+	semconv "go.opentelemetry.io/otel/semconv/v1.4.0"
+
+	"github.com/sourcegraph/sourcegraph/internal/goroutine"
+	internalgrpc "github.com/sourcegraph/sourcegraph/internal/grpc"
+	"github.com/sourcegraph/sourcegraph/internal/grpc/defaults"
+	"github.com/sourcegraph/sourcegraph/internal/httpserver"
+	"github.com/sourcegraph/sourcegraph/internal/observation"
+	"github.com/sourcegraph/sourcegraph/internal/pubsub"
+	"github.com/sourcegraph/sourcegraph/internal/service"
+	"github.com/sourcegraph/sourcegraph/internal/version"
+	"github.com/sourcegraph/sourcegraph/lib/errors"
+
+	"github.com/sourcegraph/sourcegraph/cmd/telemetry-gateway/internal/diagnosticsserver"
+	"github.com/sourcegraph/sourcegraph/cmd/telemetry-gateway/internal/server"
+	telemetrygatewayv1 "github.com/sourcegraph/sourcegraph/internal/telemetrygateway/v1"
+)
+
+func Main(ctx context.Context, obctx *observation.Context, ready service.ReadyFunc, config *Config) error {
+	shutdownOtel, err := initOpenTelemetry(ctx, obctx.Logger, config.OpenTelemetry)
+	if err != nil {
+		return errors.Wrap(err, "initOpenTelemetry")
+	}
+	defer shutdownOtel()
+
+	var eventsTopic pubsub.TopicClient
+	if !config.Events.PubSub.Enabled {
+		obctx.Logger.Warn("pub/sub events publishing disabled, logging messages instead")
+		eventsTopic = pubsub.NewLoggingTopicClient(obctx.Logger)
+	} else {
+		eventsTopic, err = pubsub.NewTopicClient(config.Events.PubSub.ProjectID, config.Events.PubSub.TopicID)
+		if err != nil {
+			return errors.Errorf("create Events Pub/Sub client: %v", err)
+		}
+	}
+
+	// Initialize our gRPC server
+	// TODO(@bobheadxi): Maybe don't use defaults.NewServer, which is geared
+	// towards in-Sourcegraph services.
+	grpcServer := defaults.NewServer(obctx.Logger)
+	defer grpcServer.GracefulStop()
+	telemetryGatewayServer, err := server.New(obctx.Logger, eventsTopic)
+	if err != nil {
+		return errors.Wrap(err, "init telemetry gateway server")
+	}
+	telemetrygatewayv1.RegisterTelemeteryGatewayServiceServer(grpcServer, telemetryGatewayServer)
+
+	// Start up the service
+	addr := config.GetListenAdress()
+	server := httpserver.NewFromAddr(
+		addr,
+		&http.Server{
+			ReadTimeout:  2 * time.Minute,
+			WriteTimeout: 2 * time.Minute,
+			Handler: internalgrpc.MultiplexHandlers(
+				grpcServer,
+				diagnosticsserver.NewDiagnosticsHandler(
+					obctx.Logger,
+					config.DiagnosticsSecret,
+					func(ctx context.Context) error {
+						if err := eventsTopic.Ping(ctx); err != nil {
+							return errors.Wrap(err, "eventsPubSubClient.Ping")
+						}
+						return nil
+					},
+				),
+			),
+		},
+	)
+
+	// Mark health server as ready and go!
+	ready()
+	obctx.Logger.Info("service ready", log.String("address", addr))
+
+	// Block until done
+	goroutine.MonitorBackgroundRoutines(ctx, server)
+	return nil
+}
+
+func initOpenTelemetry(ctx context.Context, logger log.Logger, config OpenTelemetryConfig) (func(), error) {
+	res, err := getOpenTelemetryResource(ctx)
+	if err != nil {
+		return nil, err
+	}
+
+	// Enable tracing, at this point tracing wouldn't have been enabled yet because
+	// we run Cody Gateway without conf which means Sourcegraph tracing is not enabled.
+	shutdownTracing, err := maybeEnableTracing(ctx,
+		logger.Scoped("tracing", "OpenTelemetry tracing"),
+		config, res)
+	if err != nil {
+		return nil, errors.Wrap(err, "maybeEnableTracing")
+	}
+
+	shutdownMetrics, err := maybeEnableMetrics(ctx,
+		logger.Scoped("metrics", "OpenTelemetry metrics"),
+		config, res)
+	if err != nil {
+		return nil, errors.Wrap(err, "maybeEnableMetrics")
+	}
+
+	return func() {
+		var wg conc.WaitGroup
+		wg.Go(shutdownTracing)
+		wg.Go(shutdownMetrics)
+		wg.Wait()
+	}, nil
+}
+
+func getOpenTelemetryResource(ctx context.Context) (*resource.Resource, error) {
+	// Identify your application using resource detection
+	return resource.New(ctx,
+		// Use the GCP resource detector to detect information about the GCP platform
+		resource.WithDetectors(gcp.NewDetector()),
+		// Keep the default detectors
+		resource.WithTelemetrySDK(),
+		// Add your own custom attributes to identify your application
+		resource.WithAttributes(
+			semconv.ServiceNameKey.String("telemetry-gateway"),
+			semconv.ServiceVersionKey.String(version.Version()),
+		),
+	)
+}
diff --git a/cmd/telemetry-gateway/shared/metrics.go b/cmd/telemetry-gateway/shared/metrics.go
new file mode 100644
index 00000000000..a9b65770470
--- /dev/null
+++ b/cmd/telemetry-gateway/shared/metrics.go
@@ -0,0 +1,58 @@
+package shared
+
+import (
+	"context"
+	"time"
+
+	gcpmetricexporter "github.com/GoogleCloudPlatform/opentelemetry-operations-go/exporter/metric"
+	"github.com/sourcegraph/log"
+	"go.opentelemetry.io/otel"
+	sdkmetric "go.opentelemetry.io/otel/sdk/metric"
+	"go.opentelemetry.io/otel/sdk/resource"
+
+	"github.com/sourcegraph/sourcegraph/internal/tracer/oteldefaults/exporters"
+	"github.com/sourcegraph/sourcegraph/lib/errors"
+)
+
+func maybeEnableMetrics(_ context.Context, logger log.Logger, config OpenTelemetryConfig, otelResource *resource.Resource) (func(), error) {
+	var reader sdkmetric.Reader
+	if config.GCPProjectID != "" {
+		logger.Info("initializing GCP trace exporter", log.String("projectID", config.GCPProjectID))
+		exporter, err := gcpmetricexporter.New(
+			gcpmetricexporter.WithProjectID(config.GCPProjectID))
+		if err != nil {
+			return nil, errors.Wrap(err, "gcpmetricexporter.New")
+		}
+		reader = sdkmetric.NewPeriodicReader(exporter,
+			sdkmetric.WithInterval(30*time.Second))
+	} else {
+		logger.Info("initializing Prometheus exporter")
+		var err error
+		reader, err = exporters.NewPrometheusExporter()
+		if err != nil {
+			return nil, errors.Wrap(err, "exporters.NewPrometheusExporter")
+		}
+	}
+
+	// Create and set global tracer
+	provider := sdkmetric.NewMeterProvider(
+		sdkmetric.WithReader(reader),
+		sdkmetric.WithResource(otelResource))
+	otel.SetMeterProvider(provider)
+
+	logger.Info("metrics configured")
+	return func() {
+		shutdownCtx, cancel := context.WithTimeout(context.Background(), 10*time.Second)
+		defer cancel()
+
+		start := time.Now()
+		logger.Info("Shutting down metrics")
+		if err := provider.ForceFlush(shutdownCtx); err != nil {
+			logger.Warn("error occurred force-flushing metrics", log.Error(err))
+		}
+		if err := provider.Shutdown(shutdownCtx); err != nil {
+			logger.Warn("error occured shutting down metrics", log.Error(err))
+		}
+		logger.Info("metrics shut down", log.Duration("elapsed", time.Since(start)))
+	}, nil
+}
diff --git a/cmd/telemetry-gateway/shared/service.go b/cmd/telemetry-gateway/shared/service.go
new file mode 100644
index 00000000000..d261c8b8396
--- /dev/null
+++ b/cmd/telemetry-gateway/shared/service.go
@@ -0,0 +1,31 @@
+package shared
+
+import (
+	"context"
+
+	"github.com/sourcegraph/sourcegraph/internal/debugserver"
+	"github.com/sourcegraph/sourcegraph/internal/env"
+	"github.com/sourcegraph/sourcegraph/internal/observation"
+	"github.com/sourcegraph/sourcegraph/internal/service"
+)
+
+// Service is the shared ping service.
+var Service service.Service = svc{}
+
+type svc struct{}
+
+func (svc) Name() string { return "telemetry-gateway" }
+
+func (svc) Configure() (env.Config, []debugserver.Endpoint) {
+	c := &Config{}
+	c.Load()
+	return c, []debugserver.Endpoint{
+		// Requires GRPC_WEB_UI_ENABLED to be set to enable - only use in local
+		// development!
+		debugserver.NewGRPCWebUIEndpoint("telemetry-gateway", c.GetListenAdress()),
+	}
+}
+
+func (svc) Start(ctx context.Context, observationCtx *observation.Context, ready service.ReadyFunc, config env.Config) error {
+	return Main(ctx, observationCtx, ready, config.(*Config))
+}
diff --git a/cmd/telemetry-gateway/shared/tracing.go b/cmd/telemetry-gateway/shared/tracing.go
new file mode 100644
index 00000000000..c1196bee609
--- /dev/null
+++ b/cmd/telemetry-gateway/shared/tracing.go
@@ -0,0 +1,77 @@
+package shared
+
+import (
+	"context"
+	"time"
+
+	"github.com/sourcegraph/log"
+
+	gcptraceexporter "github.com/GoogleCloudPlatform/opentelemetry-operations-go/exporter/trace"
+	"go.opentelemetry.io/otel"
+	"go.opentelemetry.io/otel/sdk/resource"
+	sdktrace "go.opentelemetry.io/otel/sdk/trace"
+
+	"github.com/sourcegraph/sourcegraph/internal/trace/policy"
+	"github.com/sourcegraph/sourcegraph/internal/tracer/oteldefaults"
+	"github.com/sourcegraph/sourcegraph/internal/tracer/oteldefaults/exporters"
+	"github.com/sourcegraph/sourcegraph/lib/errors"
+)
+
+// maybeEnableTracing configures OpenTelemetry tracing if the GOOGLE_CLOUD_PROJECT is set.
+// It differs from Sourcegraph's default tracing because we need to export directly to GCP,
+// and the use case is more niche as a standalone service.
+//
+// Based on https://cloud.google.com/trace/docs/setup/go-ot
+func maybeEnableTracing(ctx context.Context, logger log.Logger, config OpenTelemetryConfig, otelResource *resource.Resource) (func(), error) {
+	// Set globals
+	policy.SetTracePolicy(config.TracePolicy)
+	otel.SetTextMapPropagator(oteldefaults.Propagator())
+	otel.SetErrorHandler(otel.ErrorHandlerFunc(func(err error) {
+		logger.Debug("OpenTelemetry error", log.Error(err))
+	}))
+
+	// Initialize exporter
+	var exporter sdktrace.SpanExporter
+	if config.GCPProjectID != "" {
+		logger.Info("initializing GCP trace exporter", log.String("projectID", config.GCPProjectID))
+		var err error
+		exporter, err = gcptraceexporter.New(
+			gcptraceexporter.WithProjectID(config.GCPProjectID),
+			gcptraceexporter.WithErrorHandler(otel.ErrorHandlerFunc(func(err error) {
+				logger.Warn("gcptraceexporter error", log.Error(err))
+			})),
+		)
+		if err != nil {
+			return nil, errors.Wrap(err, "gcptraceexporter.New")
+		}
+	} else {
+		logger.Info("initializing OTLP exporter")
+		var err error
+		exporter, err = exporters.NewOTLPTraceExporter(ctx, logger)
+		if err != nil {
+			return nil, errors.Wrap(err, "exporters.NewOTLPExporter")
+		}
+	}
+
+	// Create and set global tracer
+	provider := sdktrace.NewTracerProvider(
+		sdktrace.WithBatcher(exporter),
+		sdktrace.WithResource(otelResource))
+	otel.SetTracerProvider(provider)
+
+	logger.Info("tracing configured")
+	return func() {
+		shutdownCtx, cancel := context.WithTimeout(context.Background(), 10*time.Second)
+		defer cancel()
+
+		start := time.Now()
+		logger.Info("Shutting down tracing")
+		if err := provider.ForceFlush(shutdownCtx); err != nil {
+			logger.Warn("error occurred force-flushing traces", log.Error(err))
+		}
+		if err := provider.Shutdown(shutdownCtx); err != nil {
+			logger.Warn("error occured shutting down tracing", log.Error(err))
+		}
+		logger.Info("Tracing shut down", log.Duration("elapsed", time.Since(start)))
+	}, nil
+}
diff --git a/enterprise/cmd/worker/internal/telemetrygatewayexporter/BUILD.bazel b/enterprise/cmd/worker/internal/telemetrygatewayexporter/BUILD.bazel
new file mode 100644
index 00000000000..3e2546f5fd1
--- /dev/null
+++ b/enterprise/cmd/worker/internal/telemetrygatewayexporter/BUILD.bazel
@@ -0,0 +1,28 @@
+load("@io_bazel_rules_go//go:def.bzl", "go_library")
+
+go_library(
+    name = "telemetrygatewayexporter",
+    srcs = [
+        "backlog_metrics.go",
+        "exporter.go",
+        "queue_cleanup.go",
+        "telemetrygatewayexporter.go",
+    ],
+    importpath = "github.com/sourcegraph/sourcegraph/enterprise/cmd/worker/internal/telemetrygatewayexporter",
+    visibility = ["//enterprise/cmd/worker:__subpackages__"],
+    deps = [
+        "//cmd/worker/shared/init/db",
+        "//internal/conf",
+        "//internal/database",
+        "//internal/env",
+        "//internal/goroutine",
+        "//internal/metrics",
+        "//internal/observation",
+        "//internal/telemetrygateway",
+        "//internal/trace",
+        "//lib/errors",
+        "@com_github_prometheus_client_golang//prometheus",
+        "@com_github_prometheus_client_golang//prometheus/promauto",
+        "@com_github_sourcegraph_log//:log",
+    ],
+)
diff --git a/enterprise/cmd/worker/internal/telemetrygatewayexporter/backlog_metrics.go b/enterprise/cmd/worker/internal/telemetrygatewayexporter/backlog_metrics.go
new file mode 100644
index 00000000000..fc29f7b97f4
--- /dev/null
+++ b/enterprise/cmd/worker/internal/telemetrygatewayexporter/backlog_metrics.go
@@ -0,0 +1,48 @@
+package telemetrygatewayexporter
+
+import (
+	"context"
+	"time"
+
+	"github.com/prometheus/client_golang/prometheus"
+	"github.com/prometheus/client_golang/prometheus/promauto"
+
+	"github.com/sourcegraph/sourcegraph/internal/database"
+	"github.com/sourcegraph/sourcegraph/internal/goroutine"
+	"github.com/sourcegraph/sourcegraph/lib/errors"
+)
+
+type backlogMetricsJob struct {
+	store database.TelemetryEventsExportQueueStore
+
+	sizeGauge prometheus.Gauge
+}
+
+func newBacklogMetricsJob(store database.TelemetryEventsExportQueueStore) goroutine.BackgroundRoutine {
+	job := &backlogMetricsJob{
+		store: store,
+		sizeGauge: promauto.NewGauge(prometheus.GaugeOpts{
+			Namespace: "src",
+			Subsystem: "telemetrygatewayexport",
+			Name:      "backlog_size",
+			Help:      "Current number of events waiting to be exported.",
+		}),
+	}
+	return goroutine.NewPeriodicGoroutine(
+		context.Background(),
+		job,
+		goroutine.WithName("telemetrygatewayexporter.backlog_metrics"),
+		goroutine.WithDescription("telemetrygatewayexporter backlog metrics"),
+		goroutine.WithInterval(time.Minute*5),
+	)
+}
+
+func (j *backlogMetricsJob) Handle(ctx context.Context) error {
+	count, err := j.store.CountUnexported(ctx)
+	if err != nil {
+		return errors.Wrap(err, "store.CountUnexported")
+	}
+	j.sizeGauge.Set(float64(count))
+
+	return nil
+}
